# matrix-bot

A Matrix-Bot which is able to:
- create default rooms and add all users to them
- create rooms from projects and add/remove their members/non-members
- give/remove Admin and Moderator role to users with/without a certain group membership

# How it works

1. create default rooms
2. load users and their groups from matrix and ldap
3. create rooms for all projects which end in `lab`
4. create rooms for all projects which have `sophomorixMailList=TRUE`
5. load all rooms (created by the bot) and their power levels from matrix
6. sync user memberships and power levels

# How to use

.matrix-bot.env:
```env
MATRIX_BOT_LDAP_URI="ldap://10.0.0.1"
MATRIX_BOT_LDAP_BASE_DN=DC=linuxmuster,DC=lan
MATRIX_BOT_LDAP_BIND_DN=CN=global-binduser,OU=Management,OU=GLOBAL,DC=linuxmuster,DC=lan
MATRIX_BOT_LDAP_BIND_DN_PASSWORD=SomeSuperSafePassword
MATRIX_BOT_MATRIX_SERVER="https://matrix.org"
MATRIX_BOT_MATRIX_DOMAIN="matrix.org"
MATRIX_BOT_MATRIX_SPACE_ID="!bajjed:matrix.org"
MATRIX_BOT_MATRIX_USERNAME="synapse"
MATRIX_BOT_MATRIX_PASSWORD="SomeSuperSafePassword"
MATRIX_BOT_DEFAULT_ROOMS="info,talk,show"
MATRIX_BOT_ADMIN_GROUP="p_admin"
MATRIX_BOT_MODERATOR_GROUP="p_moderator"
```

docker-compose.yaml:
```yaml
version: "3"
services:
  matrix-bot:
    image: git.makerlab-murnau.de/makerlab/matrix-bot:latest
    env_file: .matrix-bot.env
```